#include <iostream.h>
#define TRUE 1
#define FALSE 0
typedef int Boolean;
typedef struct L *Lref; // :    .
typedef struct T *Tref; // :    .

//   .
typedef struct L 
{ 
  int Key; //  .
  int Count; // .
  Boolean Flag; //    .
  Tref Trail; //   .
  Lref Next; //       .
} Leader;

//   .
typedef struct T 
{ 
  Lref Id; 
  Tref Next; 
} Trailer;

//   .
typedef Tref TipElement;
typedef struct Zveno *svqz;
typedef struct Zveno 
{ 
  TipElement Element; //   .
  svqz Sled; 
} St;

class Spisok
{
  private:
    Lref Head; //     .
    Lref Tail; //    
               //     .
    void SearchGraph (int, Lref *);
    void W_S (svqz *, TipElement);
    void YDALENIE (svqz *, TipElement *);
  public:
    Spisok() {//   .
              Head = Tail =  new (Leader); }
    Lref GetHead() { return Head; }
    Lref GetTail() { return Tail; }
    void MakeGraph ();
    void PrintGraph ();
    void Path_Depth_First_Search (int, int);
};

void main ()
{
  Spisok A;
  int B,E;
  Lref t; //    
          //    .
  //      .
  A.MakeGraph ();
  A.PrintGraph (); cout<<endl;
  //      .
  t = A.GetHead();
  while (t!=A.GetTail())
    { (*t).Flag = TRUE; t = (*t).Next; }
  cout << "   : "; cin >> B;
  cout << "    : "; cin >> E;
  cout << " : ";
  A.Path_Depth_First_Search (B,E); cout<<endl;
} 

void Spisok::SearchGraph (int w, Lref *h)
//      
//  w  ,      Head. 
{
  *h = Head; (*Tail).Key = w;
  while ((**h).Key!=w) *h = (**h).Next;
  if (*h==Tail)
  //        w.
  //     Head.
  { Tail = new (Leader); (**h).Count = 0; 
    (**h).Trail = NULL; (**h).Next = Tail; }
}

void Spisok::MakeGraph ()
//   Head   
//,   .
{
  int x,y;
  Lref p,q; // .
  Tref t,r; // .
  Boolean Res; //  .
  cout<<"   : ";
  cin>>x;
  while (x!=0)
  {
     cout<<"   : "; cin>>y;
     //,      (x,y)?
     SearchGraph (x, &p); SearchGraph (y,&q);
     r = (*p).Trail; Res = FALSE; 
     while ((r!=NULL)&&(!Res)) 
       if ((*r).Id==q) Res = TRUE; 
       else r = (*r).Next; 
     if (!Res) //  ,     .
      { t = new (Trailer); (*t).Id = q; 
        (*t).Next = (*p).Trail; (*p).Trail = t; (*q).Count++; } 
     cout<<"   : "; cin>>x;
  }
}

void Spisok::PrintGraph ()
//  ,   
//Head    .
{
  Lref p; // .
  Tref q; // .

  p = Head;
  while (p!=Tail)
  {
     cout<<"("<<(*p).Key; q = (*p).Trail; 
     while (q!=NULL) 
      { cout<<(*(*q).Id).Key; q = (*q).Next; } 
     cout<<")"; p = (*p).Next; cout<<" ";
  }
}

void Spisok::W_S (svqz *stk, TipElement el)
//  el   stk.
{
  svqz q=new (St);
  (*q).Element = el; (*q).Sled = *stk; *stk = q;
}

void Spisok::YDALENIE (svqz *stk, TipElement *klad)
//   ,   *stk. 
//     - 
//   klad.
{
  svqz q;

  if (*stk==NULL) cout<<"    !\n";
  else
   { *klad = (**stk).Element; q = *stk; *stk = (**stk).Sled; delete q; }
}

void Spisok::Path_Depth_First_Search (int B, int E)
//   B  E  ,   Head.
{
  Lref s,r;
  Tref t;
  svqz UkZv; //     .                

  svqz Stack = NULL; // .
  //    B
  s = Head;
  while  (s!=Tail)
  {
    if  (s->Key==B)  r = s;
    s = s->Next;
  }
  //      
  //     .
  if (r->Key==E) goto Metka;
  r->Flag = FALSE; W_S (&Stack,r->Trail);
  while (Stack!=NULL)
  {
    // "" .
    t = Stack->Element;
    if  (t->Id->Trail!=NULL)
    //     .
    {
      if (t->Id->Flag)
      //   
      //  .
      {
        //  
        //        .
        if (t->Id->Key==E) goto Metka;
        t->Id->Flag = FALSE;
        W_S (&Stack,t->Id->Trail);
      }
      //   
      //  .
      else
      {
         t = Stack->Element;
         if (t->Next!=NULL)
         //    
         //    ...
         {
            YDALENIE (&Stack,&t);
            W_S (&Stack,t->Next);
         }
         //   .
         else  YDALENIE (&Stack,&t);
      }
    }
    //     .
    else
    {
      if  (t->Id->Flag)
      //  .
      {
         if  (t->Id->Key==E) goto Metka;
         t->Id->Flag = FALSE;
      }
      t = Stack->Element;
      if  (t->Next!=NULL)
      //    
      //    ...
      {
            YDALENIE (&Stack,&t);
            W_S (&Stack,t->Next);
      }
      //   .
      else  YDALENIE (&Stack,&t);
    }
  }
Metka:
  UkZv = Stack;
  while ( UkZv!=NULL )
  {
    cout << UkZv->Element->Id->Key << " ";
    UkZv = UkZv->Sled;
  }
  cout << B << endl;
}
